#include <iostream>
#include <cstdlib>

using namespace std;

class Polygon
{
	protected:
		int length, width;
	public:
		void set_values(int l, int w)
		{
			length = l;
			width = w;
		}
		virtual int area ()
		{
			return 0;
		}

		//Pure virtual function:
		//
		//virtual int area() = 0;

};

class Rectangle : public Polygon
{
	public:
		int area()
		{
			return length * width;
		}
};

class Triangle : public Polygon
{
	public:
		int area()
		{
			return (length * width) / 2;
		}
};

int main()
{
	Polygon poly;
	Rectangle rec;
	Triangle tri;
	Polygon *poly1 = &poly;
	Polygon *poly2 = &rec;
	Polygon *poly3 = &tri;
	poly1->set_values(4,5);
	poly2->set_values(4,5);
	poly3->set_values(4,5);
	cout << poly1-> area() << endl;
	cout << poly2-> area() << endl;
	cout << poly3-> area() << endl;

	//Code for pure virtual function
	//	Rectangle rec;
	//	Triangle tri;
	//	Polygon *poly2 = &rec;
	//	Polygon *poly3 = &tri;
	//	poly2->set_values(4,5);
	//	poly3->set_values(4,5);
	//	cout << poly2-> area() << endl;
	//	cout << poly3-> area() << endl;

	return 0;
}
