#include <iostream>
#include <cstdlib>
#include <ctime>

using namespace std;

template <class Item>
void bubble_sort(Item a[], int length);

template <class Item>
void swap(Item *a, Item *b);

template <class Item>
void display_array(Item randVar, int length);

int main()
{
	int size;

	srand((unsigned)time(NULL));
	cout << "How many integers are to be sorted?" << endl;
	cin >> size;

	int randNum[size-1];

    for (int i = 0; i < size; i++)
    {
        randNum[i] = 1 + rand() % 10;
    }

	display_array(randNum, size);

	cout << endl << "sorted..." << endl;

	bubble_sort(randNum, size);

	display_array(randNum, size);

	cout << endl << endl;

    string randString[3] = {"Text2","Text3","Text1"};

    display_array(randString,3);

    cout << endl << "sorted..." << endl;

    bubble_sort(randString,3);

    display_array(randString,3);

    cout << endl << endl;

	system("pause");
	return 0;

}


//=============================
template <class Item>
void bubble_sort(Item a[], int length)
{
	int i, j;
	for (i=1; i<length; i++)
	{
		for (j=0; j<length-1; j++)
		{
			if (a[j] > a[j+1])
				swap(&a[j], &a[j+1]);
		}
	}

}

template <class Item>
void swap(Item *a, Item *b)
{
        Item temp;
        temp = *a;
        *a = *b;
        *b = temp;
}

template <class Item>
void display_array(Item randVar, int length)
{
    for ( int j = 0; j < length; j++ )
    {
        cout  << randVar[j] << " " ;
    }
}
